zoukankan      html  css  js  c++  java
  • hdu 2825 Wireless Password(ac自己主动机&dp)

    Wireless Password

    Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
    Total Submission(s): 4022    Accepted Submission(s): 1196


    Problem Description
    Liyuan lives in a old apartment. One day, he suddenly found that there was a wireless network in the building. Liyuan did not know the password of the network, but he got some important information from his neighbor. He knew the password consists only of lowercase letters 'a'-'z', and he knew the length of the password. Furthermore, he got a magic word set, and his neighbor told him that the password included at least k words of the magic word set (the k words in the password possibly overlapping).

    For instance, say that you know that the password is 3 characters long, and the magic word set includes 'she' and 'he'. Then the possible password is only 'she'.

    Liyuan wants to know whether the information is enough to reduce the number of possible passwords. To answer this, please help him write a program that determines the number of possible passwords.
     

    Input
    There will be several data sets. Each data set will begin with a line with three integers n m k. n is the length of the password (1<=n<=25), m is the number of the words in the magic word set(0<=m<=10), and the number k denotes that the password included at least k words of the magic set. This is followed by m lines, each containing a word of the magic set, each word consists of between 1 and 10 lowercase letters 'a'-'z'. End of input will be marked by a line with n=0 m=0 k=0, which should not be processed.
     

    Output
    For each test case, please output the number of possible passwords MOD 20090717.
     

    Sample Input
    10 2 2 hello world 4 1 1 icpc 10 0 0 0 0 0
     

    Sample Output
    2 1 14195065
     

    Source
     

    Recommend
    gaojie   |   We have carefully selected several similar problems for you:  2819 2824 2817 2823 2822 
     题意:
    某人要去破译wifipassword。如今他已经知道password所有由小写字母组成。且password的长度n(1<=n<=25)。和m(0<=m<=10)个password中可能出现的串(magic)。每一个串长度不超过10.如今他已经知道password中这m个串至少出现了k个。能够覆盖出现。如今问你password可能有多少种。
    思路:
    因为是专门搜的ac自己主动机动规的题目。所以就直接往ac自己主动机动规上想了。这题的难点是确定出现magic中出现了多少个。考虑到m比較小。所以就直接壮压了。最后才取满足条件的状态即可了。
    具体见代码:
    #include<algorithm>
    #include<iostream>
    #include<string.h>
    #include<sstream>
    #include<stdio.h>
    #include<math.h>
    #include<vector>
    #include<string>
    #include<queue>
    #include<set>
    #include<map>
    using namespace std;
    const int INF=0x3f3f3f3f;
    const double eps=1e-8;
    const double PI=acos(-1.0);
    const int mod=20090717;
    const int md=150;
    const int ssz=26;
    const int maxn=30;
    int ch[md][ssz],val[md],f[md],last[md];
    int sz,dp[maxn][md][1<<11],one[1<<11],bi[11];
    int idx(char c) { return c-'a'; }
    void init()
    {
        sz=1;
        val[0]=0;
        memset(ch[0],0,sizeof ch[0]);
    }
    void Insert(char *s,int v)
    {
        int u=0,n=strlen(s);
        for(int i=0; i<n; i++)
        {
            int c=idx(s[i]);
            if(!ch[u][c])
            {
                memset(ch[sz],0,sizeof ch[sz]);
                val[sz]=0;
                ch[u][c]=sz++;
            }
            u=ch[u][c];
        }
        val[u]=v;
    }
    void getf()
    {
        queue<int> q;
        int u,v,c,r;
        f[0]=0;
        for(c=0;c<ssz;c++)
        {
            u=ch[0][c];
            if(u)
            {
                f[u]=0;
                q.push(u);
                last[u]=0;
            }
        }
        while(!q.empty())
        {
            r=q.front();
            q.pop();
            val[r]|=val[f[r]];
            for(c=0;c<ssz;c++)
            {
                u=ch[r][c];
                if(!u)
                {
                    ch[r][c]=ch[f[r]][c];
                    continue;
                }
                q.push(u);
                v=f[r];
                while(v&&!ch[v][c])
                    v=f[v];
                f[u]=ch[v][c];
            }
        }
    }
    void solve(int n,int k,int ms)
    {
        int i,j,s,c,v,ns,ans;
        getf();
        for(i=0;i<=n;i++)
            for(j=0;j<sz;j++)
                for(s=0;s<ms;s++)
                    dp[i][j][s]=0;
        dp[0][0][0]=1;
        for(i=0;i<n;i++)
            for(j=0;j<sz;j++)
                for(s=0;s<ms;s++)
                {
                    if(!dp[i][j][s])
                        continue;
                    for(c=0;c<ssz;c++)
                    {
                        v=ch[j][c],ns=s|val[v];
                        dp[i+1][v][ns]=(dp[i+1][v][ns]+dp[i][j][s])%mod;
                    }
                }
        ans=0;
        for(s=0;s<ms;s++)
        {
            if(one[s]<k)
                continue;
            for(i=0;i<sz;i++)
                ans=(ans+dp[n][i][s])%mod;
        }
        printf("%d
    ",ans);
    }
    int getone(int x)
    {
        int c=0;
        while(x)
        {
            c+=x&1;
            x>>=1;
        }
        return c;
    }
    int main()
    {
        int i,n,m,k;
        char magic[20];
    
        bi[0]=1;
        for(i=1;i<11;i++)
            bi[i]=bi[i-1]<<1;
        for(i=0;i<bi[10];i++)
            one[i]=getone(i);
        while(scanf("%d%d%d",&n,&m,&k),n||m||k)
        {
            init();
            for(i=0;i<m;i++)
            {
                scanf("%s",magic);
                Insert(magic,bi[i]);
            }
            solve(n,k,bi[m]);
        }
        return 0;
    }
    


  • 相关阅读:
    C# WPF全局捕获异常 防止程序崩溃闪退
    mysql数据库动态创建分区
    mysql增加修改主键_mysql怎么修改添加主键
    C#中@的用法总结(转)
    python OpenCV使用
    turtle --- 海龟绘图¶
    Python 常用趣味模块
    Eclipse中Ant的使用
    Eclipse中Ant的使用
    Thinking in java(五)
  • 原文地址:https://www.cnblogs.com/hrhguanli/p/3854780.html
Copyright © 2011-2022 走看看